-------------------------------------------------------------- 
--  Subject : Graph algorithmes, Euler Cycle
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

function Cycle( InitV, var A )       
  Stack := [ InitV, << Stack ]             -- Stack <-- InitV
  while not Null( Stack ) do               -- 
    V := Stack[ 1 ]                        -- V := "Top of the stack"
    P == A[ V ]                            -- Identify P with A[ V ]
    if not Null( P ) then                  -- if the list not empty then
      [[ U, P ]] := [ << P ]               --   U <-- P
      Stack := [ U, << Stack ]             --   Stack <-- U
      P == A[ U ]                          --   Identify P with A[ V ]
      while not Null( P ) do               --   Find out a edge and 
        if P[ 1 ] = V then                 --   delete it 
          [[ V, P ]] := [ << P ]
          goto Found                  
        end
        P == P[ 2 ]
      end
      label Found
    else                                  
      [[ *, Stack ]] := [ << Stack ]      -- dummy <-- Stack
      C := [ V, << C ]                    -- C <-- V       
    end                    
  end
return C

------------ Main program ------------------------

A := array( 9 )
A[ 1 ] := [ 2, [ 3, * ]]
A[ 2 ] := [ 1, [ 3, [ 7, [ 8, * ]]]]
A[ 3 ] := [ 1, [ 2, [ 4, [ 5, * ]]]]
A[ 4 ] := [ 3, [ 5, * ]]
A[ 5 ] := [ 3, [ 4, [ 6, [ 8, * ]]]]
A[ 6 ] := [ 5, [ 7, [ 8, [ 9, * ]]]]
A[ 7 ] := [ 2, [ 6, [ 8, [ 9, * ]]]]
A[ 8 ] := [ 2, [ 5, [ 6, [ 7, * ]]]]
A[ 9 ] := [ 6, [ 7, * ]]

C := Cycle( 1, A )

----- Output -----------

P == C
while not Null( P ) do
  writeln( P[ 1 ] )
  P == P[ 2 ]
end
return

