-------------------------------------------------------------- 
--  Subject : Non-standard arithmetics
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

class GF : Integer
  function InitGF( InitP )
  function "+"( X, Y )
  function "*"( X, Y )
  function "integer"( X )  
end

implementation GF

  local shared P

  function InitGF( InitP )
    P := InitP
  return 0

  function "+"( X, Y ) 
    Z := Integer."+"( X, Y ) 
    if Z > P then
      Integer."-"( Z, P )       
    end 
  return 0

  function "*"( X, Y )
    Z  := Integer."*"( X, Y )
    Z1 := Integer."/"( Z, P )
    Z2 := Integer."*"( Z1, P )   
    Integer."-"( Z, Z2 )
  return 0 

  function "integer"( X ) 
    ":="( X )
  return Self()

end

GF.InitGF( 5 )
object I, J : GF
I := 4
J := 3
K := I + J
L := I * J + 1

writeln( K )
writeln( L )

return
