-------------------------------------------------------------- 
--  Subject : Windows wrapper
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

constant
  WM_PAINT            = $000F
  WM_CLOSE            = $0010
end

class TForm
  function Create( iOwner, iCaption, iTop, iLeft, iWidth, iHeight ) constructor
  function Show()
  function MoveTo( X, Y )
  function LineTo( X, Y )
  function GetPenPosX()
  function GetPenPosY()
  function Paint()
  function GetRect()

  function GetHWND()
  function GetFormPointer()
  function GetCaption()

  function WindowProc( HWND, MSG )
end

implementation TForm
  local FormPointer, shared FormList

  function Init( iOwner, iCaption, iTop, iLeft, iWidth, iHeight ) external
  function GetHWND() external

  function Create( iOwner, iCaption, iTop, iLeft, iWidth, iHeight )
    FormPointer  := Init( iOwner, iCaption, iTop, iLeft, iWidth, iHeight )
    FormList := [ [ GetHWND(), Self() ], << FormList ]
  return 0

  function Show() external

  function MoveTo( X, Y ) external
  function LineTo( X, Y ) external
  function GetPenPosX() external
  function GetPenPosY() external
  function GetRect() external
  function GetHWND() external
  function Getcaption() external

  function Paint()
    writeln( 'TForm paint' )
  return 0

  function WindowProc( HWND, MSG )

    object &FormAlias : TForm

    P == FormList
    while not Null( P ) do
      if P[ 1, 1 ] = HWND then

        FormAlias == P[ 1, 2 ]

        if    MSG = WM_PAINT then
          FormAlias.Paint()
        elsif MSG = WM_CLOSE then
          writeln( 'Close ' + FormAlias.GetCaption() )
          [[ *, P ]] << [ << P ]
          writeln( '... and remove it from list' )
        end

        goto Exit

      end
      P == P[ 2 ]
    end

    label Exit

  return 0

  function GetFormPointer() inline
  return FormPointer

end

return

function InsertForm( iCaption, iTop, iLeft, iWidth, iHeight ) external

object Form, FormChild : TForm

Form.Create( -1, 'Virt form', 10, 20, 300, 200 )
Form.Show()

FormChild.Create( Form.GetFormPointer(), 'Child', 20, 10, 100, 100 )
FormChild.Show()

select FormChild

MoveTo( 0, 0 )
LineTo( 30, 30 )

return